Index: issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMesh2dx/InterpFromMesh2dx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMesh2dx/InterpFromMesh2dx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMesh2dx/InterpFromMesh2dx.cpp	(revision 12878)
@@ -7,10 +7,9 @@
 #include "../../include/include.h"
 #include "../../toolkits/toolkits.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../modules.h"
 
 int InterpFromMesh2dx( Vector** pdata_prime,double* index_data, double* x_data, double* y_data, int nods_data,int nels_data, double* data, int data_length, double* x_prime, double* y_prime, int nods_prime,
 		double* default_values,int num_default_values,Contour** contours,int numcontours){
-
 	
 	/*Output*/
@@ -41,5 +40,5 @@
 	/*some checks*/
 	if (nels_data<1 || nods_data<3 || nods_prime==0){
-		_error_("nothing to be done according to the mesh given in input");
+		_error2_("nothing to be done according to the mesh given in input");
 	}
 
@@ -55,9 +54,9 @@
 	}
 	else{
-		_error_("length of vector data not supported yet. It should be of length (number of nodes) or (number of elements)!");
+		_error2_("length of vector data not supported yet. It should be of length (number of nodes) or (number of elements)!");
 	}
 
 	if((numcontours) && (interpolation_type==2)){
-		_error_(" element interpolation_type with contours not supported yet!");
+		_error2_("element interpolation_type with contours not supported yet!");
 	}
 
@@ -72,5 +71,5 @@
 
 	/*Initialize output*/
-	data_prime=new Vector(nods_prime);
+	data_prime=new Vector(nods_prime,false,SeqVecType);
 	if(num_default_values){
 		if(num_default_values==1)for (i=0;i<nods_prime;i++) data_prime->SetValue(i,default_values[0],INS_VAL);
@@ -84,6 +83,6 @@
 	}
 	else{
-		 incontour=(double*)xmalloc(nods_prime*sizeof(double));
-		 for (i=0;i<nods_prime;i++) incontour[i]=1;
+		 incontour=xNew<double>(nods_prime);
+		 for (i=0;i<nods_prime;i++) incontour[i]=1.0;
 	}
 
@@ -112,5 +111,5 @@
 
 	/*Assign output pointers:*/
-	 xfree((void**)&incontour);
+	 xDelete<double>(incontour);
 	*pdata_prime=data_prime;
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMesh2dx/InterpFromMesh2dx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMesh2dx/InterpFromMesh2dx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMesh2dx/InterpFromMesh2dx.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _INTERPFROMMESH2DX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../toolkits/toolkits.h"
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMesh2dx/InterpFromMesh2dxt.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMesh2dx/InterpFromMesh2dxt.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMesh2dx/InterpFromMesh2dxt.cpp	(revision 12878)
@@ -8,60 +8,34 @@
 void* InterpFromMesh2dxt(void* vpthread_handle){
 
-	/*gate variables :*/
-	InterpFromMesh2dxThreadStruct* gate=NULL;
-	pthread_handle* handle=NULL;
-	int     my_thread;
-	int     num_threads;
-	
-	int interpolation_type;
-	bool debug;
-	int  nels_data;
-	double* index_data=NULL;
-	double* x_data=NULL;
-	double* y_data=NULL;
-	double* data=NULL;
-	double xmin,xmax;
-	double ymin,ymax;
-	int    nods_prime;
-	Vector*    data_prime=NULL;
-	double* x_prime=NULL;
-	double* y_prime=NULL;
-	double* default_values=NULL;
-	int     num_default_values;
-	double*    incontour=NULL;
-
 	/*intermediary: */
-	int     i0;
-	int     i1;
-	int     i,j;
-	double  area;
-	double  area_1,area_2,area_3;
+	int     i0,i1,i,j;
+	double  area,area_1,area_2,area_3;
 	double  data_value;
 
 	/*recover handle and gate: */
-	handle=(pthread_handle*)vpthread_handle;
-	gate=(InterpFromMesh2dxThreadStruct*)handle->gate;
-	my_thread=handle->id;
-	num_threads=handle->num;
+	pthread_handle                *handle      = (pthread_handle*)vpthread_handle;
+	InterpFromMesh2dxThreadStruct *gate        = (InterpFromMesh2dxThreadStruct*)handle->gate;
+	int                            my_thread   = handle->id;
+	int                            num_threads = handle->num;
 	
 	/*recover parameters :*/
-	interpolation_type=gate->interpolation_type;
-	debug=gate->debug;
-	nels_data=gate->nels_data;
-	index_data=gate->index_data;
-	x_data=gate->x_data;
-	y_data=gate->y_data;
-	data=gate->data;
-	xmin=gate->xmin;
-	xmax=gate->xmax;
-	ymin=gate->ymin;
-	ymax=gate->ymax;
-	nods_prime=gate->nods_prime;
-	data_prime=gate->data_prime;
-	x_prime=gate->x_prime;
-	y_prime=gate->y_prime;
-	default_values=gate->default_values;
-	num_default_values=gate->num_default_values;
-	incontour=gate->incontour;
+	int     interpolation_type = gate->interpolation_type;
+	bool    debug              = gate->debug;
+	int     nels_data          = gate->nels_data;
+	double *index_data         = gate->index_data;
+	double *x_data             = gate->x_data;
+	double *y_data             = gate->y_data;
+	double *data               = gate->data;
+	double  xmin               = gate->xmin;
+	double  xmax               = gate->xmax;
+	double  ymin               = gate->ymin;
+	double  ymax               = gate->ymax;
+	int     nods_prime         = gate->nods_prime;
+	Vector *data_prime         = gate->data_prime;
+	double *x_prime            = gate->x_prime;
+	double *y_prime            = gate->y_prime;
+	double *default_values     = gate->default_values;
+	int     num_default_values = gate->num_default_values;
+	double *incontour          = gate->incontour;
 
 	/*partition loop across threads: */
@@ -69,10 +43,9 @@
 
 	/*Loop over the elements*/
-	if (debug && my_thread==0) printf("      interpolation progress:   %5.2lf %%",0.0);
-
-	for (i=i0;i<i1;i++){
+	for(i=i0;i<i1;i++){
 
 		/*display current iteration*/
-		if (debug && my_thread==0 && fmod((double)i,(double)100)==0) printf("\b\b\b\b\b\b\b%5.2lf %%",(double)i/nels_data*100*num_threads);
+		if (debug && my_thread==0 && fmod((double)i,(double)100)==0)
+		 _printString_("\r      interpolation progress: "<<setw(6)<<setprecision(2)<<double(i-i0)/double(i1-i0)*100<<"%");
 
 		/*if there is no point inside the domain, go to next iteration*/
@@ -114,5 +87,5 @@
 						data_value=data[i];
 					}
-					if (isnan(data_value)){
+					if (xIsNan<IssmDouble>(data_value)){
 						if(num_default_values==1) data_value=default_values[0];
 						else data_value=default_values[j];
@@ -125,7 +98,6 @@
 		}
 	}
-	if (debug && my_thread==0) printf("\b\b\b\b\b\b\b%5.2lf %%\n",100.0);
-	
+	if(debug && my_thread==0)
+	 _printLine_("\r      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
 	return NULL;
-
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToGridx/InterpFromMeshToGridx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToGridx/InterpFromMeshToGridx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToGridx/InterpFromMeshToGridx.cpp	(revision 12878)
@@ -30,5 +30,5 @@
 	/*some checks*/
 	if (nels<1 || nods<3 || nlines<1 || ncols<1 || xposting==0 || yposting==0){
-		_error_("nothing to be done according to the mesh given in input");
+		_error2_("nothing to be done according to the mesh given in input");
 	}
 
@@ -41,11 +41,11 @@
 	}
 	else{
-		_error_("length of vector data not supported yet. It should be of length (number of nodes) or (number of elements)!");
+		_error2_("length of vector data not supported yet. It should be of length (number of nodes) or (number of elements)!");
 	}
 
 	/*First, allocate pointers: */
-	griddata=(double*)xcalloc(nlines*ncols,sizeof(double));
-	x_grid=(double*)xcalloc(ncols,sizeof(double));
-	y_grid=(double*)xcalloc(nlines,sizeof(double));
+	griddata=xNewZeroInit<double>(nlines*ncols);
+	x_grid=xNewZeroInit<double>(ncols);
+	y_grid=xNewZeroInit<double>(nlines);
 
 	/*Set debug to 1 if there are lots of elements*/
@@ -85,9 +85,9 @@
 
 	/*Loop over the elements*/
-	if (debug) printf("      interpolation progress:   %5.2lf %%",0.0);
 	for (n=0;n<nels;n++){
 
 		/*display current iteration*/
-		if (debug && fmod((double)n,(double)100)==0) printf("\b\b\b\b\b\b\b%5.2lf %%",(double)n/nels*100);
+		if (debug && fmod((double)n,(double)100)==0)
+		 _printString_("\r      interpolation progress: "<<setw(6)<<setprecision(2)<<double(n)/double(nels)*100<<"%");
 
 		/*Get extrema coordinates of current elements*/
@@ -160,5 +160,5 @@
 						data_value=data_mesh[n];
 					}
-					if (isnan(data_value)) data_value=default_value;
+					if (xIsNan<IssmDouble>(data_value)) data_value=default_value;
 
 					/*insert value and go to the next point*/
@@ -168,5 +168,6 @@
 		}
 	}
-	if (debug) printf("\b\b\b\b\b\b\b%5.2lf %%\n",100.0);
+	if (debug)
+	 _printLine_("\r      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
 
 	/*Assign output pointers:*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.cpp	(revision 12878)
@@ -7,5 +7,5 @@
 #include "../../include/include.h"
 #include "../../toolkits/toolkits.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../modules.h"
 
@@ -13,6 +13,6 @@
 using namespace std;
 
-int InterpFromMeshToMesh2dx(double** pdata_interp,double* index_data,double* x_data,double* y_data,int nods_data,int nels_data,
-			double* data,int data_rows,int data_cols,double* x_interp,double* y_interp,int nods_interp,double* default_values,int num_default_values, DataSet* contours){
+int InterpFromMeshToMesh2dx(double** pdata_interp,int* index_data,double* x_data,double* y_data,int nods_data,int nels_data,
+			double* data,int M_data,int N_data,double* x_interp,double* y_interp,int N_interp,Options* options){
 	
 	/*Output*/
@@ -20,4 +20,7 @@
 
 	/*Intermediary*/
+	double xmin,xmax,ymin,ymax;
+	bool   isdefault;
+	double defaultvalue;
 	R2     r;
 	I2     I;
@@ -29,76 +32,85 @@
 	double data_value;
 	Icoor2 dete[3];
-	int verbose=0;
-
-	/*default values: */
-	Vector*    vec_incontour=NULL;
-	double*    incontour=NULL;
-	bool   skip_bamg=false;
 
 	/*Checks*/
-	if (data_cols<=0){
-		_error_("data provided has a negative number of columns");
+	if (M_data!=nods_data && M_data!=nels_data){
+		_error2_("data provided should have either " << nods_data << " or " << nels_data << " lines (not " << M_data << ")");
 	}
-	if (data_rows!=nods_data && data_rows!=nels_data){
-		_error_("data provided should have either %i or %i lines (not %i)",nods_data,nels_data,data_rows);
+
+	/*Get default*/
+	if(options->GetOption("default")){
+		isdefault=true;
+		options->Get(&defaultvalue,"default");
 	}
-	if((num_default_values) && (data_cols>1)){
-		_error_("data provided can only have 1 column if a default value is provided");
-	}
-	
-	/*If default values supplied, figure out which nodes are inside the contour, including the border of the contour: */
-	if(num_default_values){
-		ContourToNodesx( &vec_incontour,x_interp,y_interp,nods_interp,contours,1);
-		incontour=vec_incontour->ToMPISerial();
+	else{
+		isdefault=false;
 	}
 
 	/*Initialize output*/
-	if (verbose) printf("Initializing output vector\n");
-	data_interp=(double*)xmalloc(nods_interp*data_cols*sizeof(double));
+	data_interp=xNew<double>(N_interp*N_data);
 
-	// read background mesh 
-	if (verbose) printf("Reading mesh\n");
+	/*read background mesh*/
 	Mesh Th(index_data,x_data,y_data,nods_data,nels_data); 
+
+	/*Get reference number (for subdomains)*/
+	long* reft = xNew<long>(Th.nbt);
+	Th.TriangleReferenceList(reft);
 	Th.CreateSingleVertexToTriangleConnectivity();
 
-	//Loop over output nodes
-	if (verbose) printf("Loop over the nodes\n");
-	for(i=0;i<nods_interp;i++){
-		
-		/*reset skip_bamg: */
-		skip_bamg=false;
+	/*Get domain boundaries*/
+	xmin=x_data[0]; ymin=y_data[0];
+	xmax=x_data[0]; ymax=y_data[0];
+	for(i=1;i<nods_data;i++){
+		if(x_data[i]<xmin) xmin=x_data[i];
+		if(x_data[i]>xmax) xmax=x_data[i];
+		if(y_data[i]<ymin) ymin=y_data[i];
+		if(y_data[i]>ymax) ymax=y_data[i];
+	}
 
-		/*figure out if we should skip bamg logic: */
-		if(num_default_values){
-			if(!incontour[i]){
-				/*This node is not inside the contour. Skip Bamg logic and apply default value.: */
-				skip_bamg=true;
+	/*Loop over output nodes*/
+	for(i=0;i<N_interp;i++){
+		//if(i%100==0) _printString_("\r      interpolation progress: "<<setw(6)<<setprecision(2)<<double(i)/double(N_interp)*100.<<"%");
+
+		if(isdefault){
+			if(x_interp[i]<xmin || x_interp[i]>xmax || y_interp[i]<ymin || y_interp[i]>ymax){
+				for(j=0;j<N_data;j++) data_interp[i*N_data+j]=defaultvalue;
+				continue;
 			}
 		}
 
-		if(skip_bamg==false){
+		/*Get current point coordinates*/
+		r.x=x_interp[i]; r.y=y_interp[i];
+		I2 I=Th.R2ToI2(r);
 
-			//Get current point coordinates
-			r.x=x_interp[i]; r.y=y_interp[i];
-			I2 I=Th.R2ToI2(r);
+		/*Find triangle holding r/I*/
+		Triangle &tb=*Th.TriangleFindFromCoord(I,dete);
 
-			//Find triangle holding r/I
-			Triangle &tb=*Th.TriangleFindFromCoord(I,dete);
+		/*point inside convex*/
+		if (tb.det>0){ 
 
-			// internal point 
-			if (tb.det>0){ 
-				//Area coordinate
-				areacoord[0]= (double) dete[0]/tb.det;
-				areacoord[1]= (double) dete[1]/tb.det;
-				areacoord[2]= (double) dete[2]/tb.det;
-				//3 vertices of the triangle
-				i0=Th.GetId(tb[0]);
-				i1=Th.GetId(tb[1]);
-				i2=Th.GetId(tb[2]);
-				//triangle number
-				it=Th.GetId(tb);
+			/*Area coordinates*/
+			areacoord[0]= (double) dete[0]/tb.det;
+			areacoord[1]= (double) dete[1]/tb.det;
+			areacoord[2]= (double) dete[2]/tb.det;
+			/*3 vertices of the triangle*/
+			i0=Th.GetId(tb[0]);
+			i1=Th.GetId(tb[1]);
+			i2=Th.GetId(tb[2]);
+			/*triangle number*/
+			it=Th.GetId(tb);
+
+			/*Inside convex but outside mesh*/
+			if (reft[it]<0 & isdefault){
+				for(j=0;j<N_data;j++) data_interp[i*N_data+j]=defaultvalue;
+				continue;
 			}
-			//external point
-			else {
+		}
+		//external point
+		else{
+			if(isdefault){
+				for(j=0;j<N_data;j++) data_interp[i*N_data+j]=defaultvalue;
+				continue;
+			}
+			else{
 				//Get closest adjacent triangle (inside the mesh)
 				AdjacentTriangle ta=CloseBoundaryEdge(I,&tb,aa,bb).Adj();
@@ -116,30 +128,25 @@
 				it=Th.GetId(tc);
 			}
-			
-			if (data_rows==nods_data){
-				for (j=0;j<data_cols;j++){
-					data_interp[i*data_cols+j]=areacoord[0]*data[data_cols*i0+j]+areacoord[1]*data[data_cols*i1+j]+areacoord[2]*data[data_cols*i2+j];
-				}
-			}
-			else{
-				for (j=0;j<data_cols;j++){
-					if (it<0 || it>=nels_data){
-						_error_("Triangle number %i not in [0 %i], because not correctly implemented yet... interpolate on grid first",it,nels_data);
-					}
-					data_interp[i*data_cols+j]=data[data_cols*it+j];
-				}
+		}
+
+		if (M_data==nods_data){
+			for (j=0;j<N_data;j++){
+				data_interp[i*N_data+j]=areacoord[0]*data[N_data*i0+j]+areacoord[1]*data[N_data*i1+j]+areacoord[2]*data[N_data*i2+j];
 			}
 		}
 		else{
-			if(num_default_values==1) data_interp[i]=default_values[0];
-			else data_interp[i]=default_values[i];
+			for (j=0;j<N_data;j++){
+				if (it<0 || it>=nels_data){
+					_error2_("Triangle number " << it << " not in [0 " << nels_data << "], report bug to developers");
+				}
+				data_interp[i*N_data+j]=data[N_data*it+j];
+			}
 		}
 	}
+	//if(N_interp>=100) _printLine_("\r      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
 
-	/*Assign output pointers:*/
-	if (verbose) printf("Assigning output\n");
+	/*clean-up and return*/
+	xDelete<long>(reft);
 	*pdata_interp=data_interp;
-
-	/*No error return*/
 	return 1;
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.h	(revision 12878)
@@ -6,9 +6,8 @@
 #define _INTERPFROMMESHTOMESH2DX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/classes.h"
 
-/* local prototypes: */
-int InterpFromMeshToMesh2dx(double** pdata_interp,double* index_data,double* x_data,double* y_data,int nods_data,int nels_data,
-			double* data,int data_rows,int data_cols,double* x_interp,double* y_interp,int nods_interp,double* default_values,int num_default_values,DataSet* contours);
+int InterpFromMeshToMesh2dx(double** pdata_interp,int* index_data,double* x_data,double* y_data,int nods_data,int nels_data,
+			double* data,int M_data,int N_data,double* x_interp,double* y_interp,int N_interp,Options* options);
 
 #endif
Index: issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh3dx/InterpFromMeshToMesh3dx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh3dx/InterpFromMeshToMesh3dx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh3dx/InterpFromMeshToMesh3dx.cpp	(revision 12878)
@@ -27,5 +27,5 @@
 	/*some checks*/
 	if (nels_data<1 || nods_data<6 || nods_prime==0){
-		_error_("nothing to be done according to the mesh given in input");
+		_error2_("nothing to be done according to the mesh given in input");
 	}
 
@@ -41,5 +41,5 @@
 	}
 	else{
-		_error_("length of vector data not supported yet. It should be of length (number of nodes) or (number of elements)!");
+		_error2_("length of vector data not supported yet. It should be of length (number of nodes) or (number of elements)!");
 	}
 
@@ -58,9 +58,9 @@
 
 	/*Loop over the elements*/
-	if (debug) printf("      interpolation progress:   %5.2lf %%",0.0);
 	for (i=0;i<nels_data;i++){
 
 		/*display current iteration*/
-		if (debug && fmod((double)i,(double)100)==0) printf("\b\b\b\b\b\b\b%5.2lf %%",(double)i/nels_data*100);
+		if (debug && fmod((double)i,(double)100)==0)
+		 _printString_("\r      interpolation progress: "<<setw(6)<<setprecision(2)<<double(i)/double(nels_data)*100<<"%");
 
 		/*Get extrema coordinates of current elements*/
@@ -124,5 +124,5 @@
 						data_value=data[i];
 					}
-					if (isnan(data_value)) data_value=default_value;
+					if (xIsNan<IssmDouble>(data_value)) data_value=default_value;
 
 					/*insert value and go to the next point*/
@@ -132,5 +132,6 @@
 		}
 	}
-	if (debug) printf("\b\b\b\b\b\b\b%5.2lf %%\n",100.0);
+	if (debug)
+	 _printLine_("\r      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
 
 	/*Assign output pointers:*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh3dx/InterpFromMeshToMesh3dx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh3dx/InterpFromMeshToMesh3dx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh3dx/InterpFromMeshToMesh3dx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../toolkits/toolkits.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 int InterpFromMeshToMesh3dx( Vector** pdata_prime,double* index_data, double* x_data, double* y_data, double* z_data, int nods_data,int nels_data, double* data, int data_length, double* x_prime, double* y_prime, double* z_prime, int nods_prime,double default_value);
Index: issm/branches/trunk-jpl-damage/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp	(revision 12878)
@@ -22,6 +22,6 @@
 	int     counter;
 	int     nods;
-	double* times=NULL;
-	double* values=NULL;
+	IssmDouble* times=NULL;
+	IssmDouble* values=NULL;
 	bool    spcpresent=false;
 	int     count=0;
@@ -29,5 +29,5 @@
 
 	/*variables being fetched: */
-	double *doublevector  = NULL;
+	IssmDouble *IssmDoublevector  = NULL;
 	int     M,N;
 
@@ -38,9 +38,9 @@
 	fid=iomodel->SetFilePointerToData(&code, &vector_layout,vector_enum);
 
-	if(code!=7)_error_("%s%s"," expecting a double vector for constraints with enum ",EnumToStringx(vector_enum));
-	if(vector_layout!=1)_error_("%s%s"," expecting a nodal vector for constraints with enum ",EnumToStringx(vector_enum));
+	if(code!=7)_error2_("expecting a IssmDouble vector for constraints with enum " << EnumToStringx(vector_enum));
+	if(vector_layout!=1)_error2_("expecting a nodal vector for constraints with enum " << EnumToStringx(vector_enum));
 
 	/*Fetch vector:*/
-	iomodel->FetchData(&doublevector,&M,&N,vector_enum);
+	iomodel->FetchData(&IssmDoublevector,&M,&N,vector_enum);
 
 	/*Transient or static?:*/
@@ -55,7 +55,7 @@
 			if((iomodel->my_vertices[i])){
 
-				if (!isnan(doublevector[i])){
+				if (!xIsNan<IssmDouble>(IssmDoublevector[i])){
 
-					constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,doublevector[i],analysis_type));
+					constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,IssmDoublevector[i],analysis_type));
 					count++;
 				}
@@ -69,7 +69,7 @@
 
 		/*figure out times: */
-		times=(double*)xmalloc(N*sizeof(double));
+		times=xNew<IssmDouble>(N);
 		for(j=0;j<N;j++){
-			times[j]=doublevector[(M-1)*N+j];
+			times[j]=IssmDoublevector[(M-1)*N+j];
 		}
 		/*unit conversion: */
@@ -83,9 +83,9 @@
 
 				/*figure out times and values: */
-				values=(double*)xmalloc(N*sizeof(double));
+				values=xNew<IssmDouble>(N);
 				spcpresent=false;
 				for(j=0;j<N;j++){
-					values[j]=doublevector[i*N+j];
-					if(!isnan(values[j]))spcpresent=true; //NaN means no spc by default
+					values[j]=IssmDoublevector[i*N+j];
+					if(!xIsNan<IssmDouble>(values[j]))spcpresent=true; //NaN means no spc by default
 				}
 
@@ -94,15 +94,15 @@
 					count++;
 				}
-				xfree((void**)&values);
+				xDelete<IssmDouble>(values);
 			}
 		}
 	}
 	else{
-		_error_("Size of field %s not supported",EnumToStringx(vector_enum));
+		_error2_("Size of field " << EnumToStringx(vector_enum) << " not supported");
 	}
 
 	/*Free ressources:*/
-	xfree((void**)&doublevector);
-	xfree((void**)&times);
-	xfree((void**)&values);
+	xDelete<IssmDouble>(IssmDoublevector);
+	xDelete<IssmDouble>(times);
+	xDelete<IssmDouble>(values);
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.h	(revision 12878)
@@ -6,5 +6,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/KMLFileReadx/KMLFileReadx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/KMLFileReadx/KMLFileReadx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/KMLFileReadx/KMLFileReadx.cpp	(revision 12878)
@@ -21,5 +21,5 @@
 	clock0=clock();
 	time0 =time(NULL);
-	_printf_(true,"\nKMLFileReadx Module -- %s",ctime(&time0));
+	_pprintString_("\nKMLFileReadx Module -- " << ctime(&time0));
 
 /*  read kml file  */
@@ -43,15 +43,15 @@
 		}
 
-//		_printf_(true,"%s\n",kstr);
-		xfree((void**)&kstr);
+//		_pprintLine_(kstr);
+		xDelete<char>(kstr);
 	}
 
 	if (kxml) {
-		_printf_(true,"XML declaration:\n");
+		_pprintLine_("XML declaration:");
 		kxml->DeepEcho("  ");
 		delete kxml;
 	}
 	if (kdtd) {
-		_printf_(true,"DTD declaration (not yet implemented):\n");
+		_pprintLine_("DTD declaration (not yet implemented):");
 		kdtd->DeepEcho("  ");
 		delete kdtd;
Index: issm/branches/trunk-jpl-damage/src/c/modules/KMLFileReadx/KMLFileReadx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/KMLFileReadx/KMLFileReadx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/KMLFileReadx/KMLFileReadx.h	(revision 12878)
@@ -8,5 +8,5 @@
 #include <float.h>    /*  DBL_MAX  */
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/KMLMeshWritex/KMLMeshWritex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/KMLMeshWritex/KMLMeshWritex.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/KMLMeshWritex/KMLMeshWritex.cpp	(revision 12878)
@@ -9,28 +9,18 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void KMLMeshWritex(int* ierror,
-				   char* name,
-				   char* notes,
-				   int* elem,int melem,int nelem,
-				   int* nodecon,int mncon,int nncon,
-				   double* lat, double* lng,
-				   int* part,
-				   double* data, int mdata, int ndata,
-				   double* cmap, int mcmap, int ncmap,
-				   FILE* fid){
-
-	int     i,j,k,ipt=0,jpt=0,nnodes;
-	int     mxepg=25;
-	int     lwidth=1;
-	double  popac=0.50;
-	char    indent[81]="  ";
-	char    cstr[81];
-	double* edata=NULL;
-	bool    ncfree=false,
-			edfree=false;
-	KML_Document*  kdoc=NULL;
-	KML_Style*     kstyle;
-	KML_LineStyle* klsty;
-	KML_PolyStyle* kpsty;
+void KMLMeshWritex(int* ierror,char* name,char* notes,int* elem,int melem,int nelem,int* nodecon,int mncon,int nncon,double* lat, double* lng,int* part,double* data, int mdata, int ndata,double* cmap, int mcmap, int ncmap,FILE* fid){
+
+	int                 i,j,k,ipt=0,jpt=0,nnodes;
+	int                 mxepg      = 25;
+	int                 lwidth     = 1;
+	double              popac      = 0.50;
+	char                indent[81] = " ";
+	char                cstr[81];
+	double             *edata = NULL;
+	bool ncfree=false, edfree=false;
+	KML_Document       *kdoc = NULL;
+	KML_Style          *kstyle;
+	KML_LineStyle      *klsty;
+	KML_PolyStyle      *kpsty;
 
 	clock_t clock0,clock1,clock0a,clock0b,clock0c;
@@ -39,5 +29,5 @@
 	clock0=clock();
 	time0 =time(NULL);
-	_printf_(true,"\nKMLMeshWritex Module -- %s",ctime(&time0));
+	_pprintString_("\nKMLMeshWritex Module -- " << ctime(&time0));
 
 /*  construct kml document  */
@@ -93,5 +83,5 @@
 
 	if (cmap) {
-		_printf_(true,"Writing %d Matlab colors as KML style templates.\n",mcmap);
+		_pprintLine_("Writing " << mcmap << " Matlab colors as KML style templates.");
 		ipt=0;
 		for (i=0; i<mcmap; i++) {
@@ -128,7 +118,7 @@
 
 	if (!nodecon) {
-		_printf_(true,"Creating the node connectivity table.\n");
+		_pprintLine_("Creating the node connectivity table.");
 		nncon=mxepg+1;
-		nodecon=(int *) xcalloc(mncon*nncon,sizeof(int));
+		nodecon=xNewZeroInit<int>(mncon*nncon);
 		ncfree=true;
 
@@ -143,5 +133,5 @@
 					}
 					else
-						_error_("Nodal connectivity table needs more than specified %d columns.\n",mxepg);
+						_error2_("Nodal connectivity table needs more than specified " << mxepg << " columns.\n");
 				}
 				jpt++;
@@ -159,6 +149,6 @@
 
 		else if (mdata == mncon) {
-			_printf_(true,"Averaging nodal data to element data.\n");
-			edata=(double *) xcalloc(melem*ndata,sizeof(double));
+			_pprintLine_("Averaging nodal data to element data.");
+			edata=xNewZeroInit<double>(melem*ndata);
 			edfree=true;
 
@@ -183,5 +173,5 @@
 
 		else
-			_error_("Data matrix has incorrect number of %d rows.\n",mdata);
+			_error2_("Data matrix has incorrect number of " << mdata << " rows.\n");
 	}
 
@@ -194,6 +184,6 @@
 														cmap,mcmap,ncmap));
 
-	if (edfree) xfree((void**)&edata);
-	if (ncfree) xfree((void**)&nodecon);
+	if(edfree) xDelete<double>(edata);
+	if(ncfree) xDelete<int>(nodecon);
 	clock0a=clock();
 	time0a =time(NULL);
@@ -203,5 +193,5 @@
 /*  write kml file  */
 
-	_printf_(true,"Writing kml document to file.\n");
+	_pprintLine_("Writing kml document to file.");
 	fprintf(fid,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
 	fprintf(fid,"<kml xmlns=\"http://www.opengis.net/kml/2.2\">\n");
@@ -213,5 +203,5 @@
 			 ((double)(clock0b-clock0a))/CLOCKS_PER_SEC,difftime(time0b,time0a));
 
-	_printf_(true,"Deleting kml document.\n");
+	_pprintLine_("Deleting kml document.");
 	delete kdoc;
 	clock0c=clock();
@@ -314,5 +304,5 @@
 /*  write each element as a polygon placemark  */
 
-	_printf_(true,"Writing %d tria elements as KML polygons.\n",melem);
+	_pprintLine_("Writing " << melem << " tria elements as KML polygons.");
 
 	for (i=0; i<melem; i++) {
@@ -344,29 +334,29 @@
 		kring=new KML_LinearRing();
 		kring->ncoord    =nelem+1;
-		kring->coords    =(double (*)[3]) xmalloc((nelem+1)*3*sizeof(double));
+		kring->coords =xNew<double>((nelem+1)*3);
 
 /*  write the nodal coordinates as a linear ring  */
 
 		for (j=0; j<nelem; j++) {
-			kring->coords[j][0]=lng[elem[ipt]-1];
-			kring->coords[j][1]=lat[elem[ipt]-1];
-			kring->coords[j][2]=alt;
+			kring->coords[3*j+0]=lng[elem[ipt]-1];
+			kring->coords[3*j+1]=lat[elem[ipt]-1];
+			kring->coords[3*j+2]=alt;
 			ipt++;
 		}
-		kring->coords[nelem][0]=kring->coords[0][0];
-		kring->coords[nelem][1]=kring->coords[0][1];
-		kring->coords[nelem][2]=kring->coords[0][2];
+		kring->coords[3*nelem+0]=kring->coords[3*0+0];
+		kring->coords[3*nelem+1]=kring->coords[3*0+1];
+		kring->coords[3*nelem+2]=kring->coords[3*0+2];
 //		kring->DeepEcho();
 
 /*  assemble the linear ring into polygon into placemark into folder  */
 
-		(kpoly ->outer     )->AddObject((Object*)kring);
-		(kplace->geometry  )->AddObject((Object*)kpoly);
-		(kfold ->feature   )->AddObject((Object*)kplace);
+		(kpoly ->outer   )->AddObject((Object*)kring);
+		(kplace->geometry)->AddObject((Object*)kpoly);
+		(kfold ->feature )->AddObject((Object*)kplace);
 
 //		if (!(int)fmod((double)(i+1),1000))
-//			_printf_(true,"  %d tria elements written.\n",(i+1));
+//			_pprintLine_("  " << (i+1) << " tria elements written.");
 	}
-	_printf_(true,"  %d tria elements written.\n",melem);
+	_pprintLine_("  " << melem << " tria elements written.");
 
 	return(kfold);
Index: issm/branches/trunk-jpl-damage/src/c/modules/KMLMeshWritex/KMLMeshWritex.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/KMLMeshWritex/KMLMeshWritex.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/KMLMeshWritex/KMLMeshWritex.h	(revision 12878)
@@ -8,5 +8,5 @@
 #include <float.h>    /*  DBL_MAX  */
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
